###################################################
### chunk number 1: preliminaries
###################################################
#line 87 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
options(SweaveHooks=
        list(fig=function() par(mar=c(5.1, 4.1, 1.1, 2.1))),
        width = 75,
        digits = 5,
        prompt = "R> ")


###################################################
### chunk number 2: def-gmG eval=FALSE
###################################################
## #line 134 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
## set.seed(40)
## p <- 8
## n <- 5000
## gGtrue <- randomDAG(p, prob = 0.3)
## gmG <- list(x = rmvDAG(n, gGtrue), g = gGtrue)


###################################################
### chunk number 3: exIntro1
###################################################
#line 144 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
library("pcalg")
data("gmG")


###################################################
### chunk number 4: Iplot eval=FALSE
###################################################
## #line 168 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
## stopifnot(require(Rgraphviz))# needed for all our graph plots
## par(mfrow = c(1,2))
## plot(gmG$g, main = "")
## plot(pc.fit, main = "")


###################################################
### chunk number 5: exIntroPlot
###################################################
#line 175 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
suffStat <- list(C = cor(gmG$x), n = nrow(gmG$x))
pc.fit <- pc(suffStat, indepTest = gaussCItest,
             p = ncol(gmG$x), alpha = 0.01)
#line 168 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw#from line#178#"
stopifnot(require(Rgraphviz))# needed for all our graph plots
par(mfrow = c(1,2))
plot(gmG$g, main = "")
plot(pc.fit, main = "")
#line 179 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"


###################################################
### chunk number 6: exIntroPlot
###################################################
#line 183 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
#line 168 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw#from line#183#"
stopifnot(require(Rgraphviz))# needed for all our graph plots
par(mfrow = c(1,2))
plot(gmG$g, main = "")
plot(pc.fit, main = "")
#line 184 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"


###################################################
### chunk number 7: exIntro2
###################################################
#line 218 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
ida(1, 6, cov(gmG$x), pc.fit@graph)


###################################################
### chunk number 8: exIntro3
###################################################
#line 236 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
idaFast(1, c(4,5,6), cov(gmG$x), pc.fit@graph)


###################################################
### chunk number 9: skeleton-args
###################################################
#line 623 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
showF <- function(f, width = 82) {
    ## 'width': larger than default on purpose:
    nam <- deparse(substitute(f))
    stopifnot(is.function(f))
    attr(f, "source") <- NULL # if ...
    ll <- capture.output(str(f, width=width))
    ll[1] <- sub("function *", nam, ll[1])
    writeLines(ll)
}
showF(skeleton)


###################################################
### chunk number 10: skelExpl1Plot
###################################################
#line 656 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
require("pcalg")
data("gmG")
suffStat <- list(C = cor(gmG$x), n = nrow(gmG$x))
pc.fit <- skeleton(suffStat, indepTest = gaussCItest,
                   p = ncol(gmG$x), alpha = 0.01)
par(mfrow = c(1,2))
plot(gmG$g, main = "")
plot(pc.fit, main = "")


###################################################
### chunk number 11: skelExp2Plot
###################################################
#line 682 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
data("gmD")
suffStat <- list(dm = gmD$x, nlev = c(3,2,3,4,2), adaptDF = FALSE)
skel.fit <- skeleton(suffStat, indepTest = disCItest,
                     p = ncol(gmD$x), alpha = 0.01)
par(mfrow = c(1,2))
plot(gmD$g, main = "")
plot(skel.fit, main = "")


###################################################
### chunk number 12: pc-args
###################################################
#line 725 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
showF(pc)


###################################################
### chunk number 13: pcExpl-plot
###################################################
#line 792 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
suffStat <- list(C = cor(gmG$x), n = nrow(gmG$x))
pc.fit <- pc(suffStat, indepTest=gaussCItest, p = ncol(gmG$x), alpha = 0.01)
par(mfrow = c(1,2))
plot(gmG$g, main = "")
plot(pc.fit, main = "")


###################################################
### chunk number 14: fci-args
###################################################
#line 836 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
showF(fci)


###################################################
### chunk number 15: def-fciExpl-plot eval=FALSE
###################################################
## #line 887 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
## data("gmL")
## suffStat1 <- list(C = cor(gmL$x), n = nrow(gmL$x))
## pag.est <- fci(suffStat1, indepTest= gaussCItest,
##                p = ncol(gmL$x), alpha = 0.01, labels = as.character(2:5))
## par(mfrow = c(1,2))
## plot(gmL$g, main = "")
## plot(pag.est)


###################################################
### chunk number 16: fciExpl-plot
###################################################
#line 898 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
#line 887 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw#from line#898#"
data("gmL")
suffStat1 <- list(C = cor(gmL$x), n = nrow(gmL$x))
pag.est <- fci(suffStat1, indepTest= gaussCItest,
               p = ncol(gmL$x), alpha = 0.01, labels = as.character(2:5))
par(mfrow = c(1,2))
plot(gmL$g, main = "")
plot(pag.est)
#line 899 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"


###################################################
### chunk number 17: def-gmI eval=FALSE
###################################################
## #line 938 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
## set.seed(123)
## p <- 7
## n <- 10000
## myDAG <- randomDAG(p, prob = 0.2)
## datI <- rmvDAG(n, myDAG)
## gmI <- list(x = datI, g = myDAG)


###################################################
### chunk number 18: idaExpl1
###################################################
#line 947 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
data("gmI")
suffStat <- list(C = cor(gmI$x), n = nrow(gmI$x))
pc.fit <- pc(suffStat, indepTest=gaussCItest,
             p = ncol(gmI$x), alpha = 0.01)


###################################################
### chunk number 19: idaExpl2
###################################################
#line 960 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
par(mfrow = c(1,2))
plot(gmI$g, main = "")
plot(pc.fit, main = "")


###################################################
### chunk number 20: idaExpl3
###################################################
#line 983 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
am.pdag <- wgtMatrix(pc.fit@graph)
ad <- allDags(am.pdag, am.pdag, NULL)
gDag <- vector("list", nrow(ad))
for (i in 1:nrow(ad)) gDag[[i]] <- as(matrix(ad[i, ], 7, 7), "graphNEL")
par(mfrow = c(3,2))
for (i in 1:6) plot(gDag[[i]], main = paste("DAG",i))


###################################################
### chunk number 21: plot-6DAGS
###################################################
#line 994 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
sfsmisc::mult.fig(6)
for (i in 1:6) plot(gDag[[i]], main = paste("DAG",i))


###################################################
### chunk number 22: idaExpl4
###################################################
#line 1020 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
ida(2, 5, cov(gmI$x), pc.fit@graph, method = "global", verbose = FALSE)


###################################################
### chunk number 23: ida-args
###################################################
#line 1044 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
showF(ida)


###################################################
### chunk number 24: idaExpl5
###################################################
#line 1080 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
ida(2,5, cov(gmI$x), pc.fit@graph, method = "local")


###################################################
### chunk number 25: idaFast-args
###################################################
#line 1124 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
showF(idaFast)


###################################################
### chunk number 26: ida-idaFast
###################################################
#line 1146 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
data("gmI")
suffStat <- list(C = cor(gmI$x), n = nrow(gmI$x))
pc.fit <- pc(suffStat, indepTest=gaussCItest, p=ncol(gmI$x), alpha = 0.01)

(eff.est1 <- ida(2,5, cov(gmI$x), pc.fit@graph, method="local"))
(eff.est2 <- ida(2,6, cov(gmI$x), pc.fit@graph, method="local"))
(eff.est3 <- ida(2,7, cov(gmI$x), pc.fit@graph, method="local"))

(eff.estF <- idaFast(2, c(5,6,7), cov(gmI$x), pc.fit@graph))


###################################################
### chunk number 27: turn-off-plus
###################################################
#line 1192 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
options(continue = " ") # MM: so we don't get the "+ " continuation lines


###################################################
### chunk number 28: myCItest
###################################################
#line 1195 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
myCItest <- function(x,y,S, suffStat) {
  if (length(S) == 0) {
    x. <- suffStat[,x]
    y. <- suffStat[,y]
  } else {
    rxy <- resid(lm.fit(y= suffStat[,c(x,y)], x= cbind(1, suffStat[,S])))
    x. <- rxy[,1];  y. <- rxy[,2]
  }
  cor.test(x., y.)$p.value
}


###################################################
### chunk number 29: gaussCItest-ex
###################################################
#line 1208 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
suffStat <- list(C = cor(gmG$x), n = 5000)
pc.fit <- pc(suffStat, indepTest=gaussCItest, p = 8, alpha = 0.01)


###################################################
### chunk number 30: myCItest-def-plot eval=FALSE
###################################################
## #line 1212 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
## pc.myfit <- pc(suffStat = gmG$x, indepTest = myCItest,
##                p = 8, alpha = 0.01)
## par(mfrow = c(1,2))
## plot(pc.fit, main = "")
## plot(pc.myfit, main = "")


###################################################
### chunk number 31: myCItest-ex-plot
###################################################
#line 1221 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
#line 1212 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw#from line#1221#"
pc.myfit <- pc(suffStat = gmG$x, indepTest = myCItest,
               p = 8, alpha = 0.01)
par(mfrow = c(1,2))
plot(pc.fit, main = "")
plot(pc.myfit, main = "")
#line 1222 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"


###################################################
### chunk number 32: time-tests eval=FALSE
###################################################
## #line 1243 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
## system.time(for(i in 1:10)
##             pc.fit <- pc(suffStat, indepTest=gaussCItest, p = 8, alpha = 0.01))
##       ##  User      System verstrichen
##       ## 0.593       0.000       0.594
## system.time(for(i in 1:10)
##             pc.myfit <- pc(gmG$x,  indepTest = myCItest,  p = 8, alpha = 0.01))
## ## Using  resid(lm(..)) twice:
##      ##   User      System verstrichen
##      ## 44.864       0.007      44.937
## ## Using resid(lm.fit(..)):
##      ## 10.550       0.067      10.632


###################################################
### chunk number 33: sessionInfo
###################################################
#line 1260 "d:/Rcompile/CRANpkg/local/2.12/pcalg/inst/doc/pcalgDoc.Rnw"
toLatex(sessionInfo())


